︠05ffa71e-daa9-4e6a-875a-971ee6e56c39︠
# Exemplos Numpy Arrays
︡4ba7f58f-44f4-45a9-9b9f-1b93fd03f7b4︡︡
︠56ed8a3d-f16d-46d1-83e7-2befe7efb990︠
# Resolvendo duas Incógnitas com duas Equações Lineares

from numpy import *
from numpy.linalg import solve

# 3*x0-1*x1 = 4 
# 2*x0-3*x1 = -2
# Equação na forma ax=b

a = array([[3,-1], [2,-3]])   
b = array([4, -2])            
x = solve(a, b)
x
︡e226eb84-06d3-4f0b-ade3-bba080ab6b6b︡{"stdout": "array([ 2.,  2.])"}︡
︠a9e2444a-7c09-4f6f-b2e4-24c2071619d3︠
dot(a, x) # Verificando o resultado encontrado (b=a*x)
︡0df4dbcf-9b29-43b5-9575-40a2c1b7e59a︡{"stdout": "array([ 4., -2.])"}︡
︠d3773b39-d0be-4975-9a00-aa383f7bbe3b︠
# Resolvendo duas Incógnitas com duas Equações Lineares (2)

from numpy import *
from numpy.linalg import solve

# 1*x0-3*x1 = -4
# 2*x0-6*x1 = -8
# Como as equações acima são L.D. não será possível resolver o sistema, pois ele terá múltiplas soluções:
a = array([[1,-3], [2,-6]])
b = array([-4, -8])
x = solve(a, b)
︡c6386c8f-9597-4efd-954a-67753440fcc3︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"/home/sage/sagenb/sage_notebook/worksheets/neumara/2/code/14.py\", line 16, in <module>\n    exec compile(ur'x = solve(a, b)' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/home/sage/sage_install/sage/local/lib/python2.6/site-packages/numpy/linalg/linalg.py\", line 254, in solve\n    raise LinAlgError, 'Singular matrix'\nnumpy.linalg.linalg.LinAlgError: Singular matrix"}︡
︠8fc17efe-d5e8-4844-b834-803ab5d2dadc︠
# Resolvendo três Incógnitas com três Equações Lineares

from numpy import *
from numpy.linalg import solve
from numpy.linalg import inv

# 3*x0-3*x1+7*x2 = 2
# 4*x0-6*x1-1*x2 = -4
#-5*x0+1*x1+4*x2 = 5
a = array([[3, -3, 7], [4,-6,-1], [-5,1,4]])
b = array([2, -4, 5])
x = solve(a, b)
x
︡2941b4e5-e4ac-4c04-86bf-68d66a180d1b︡{"stdout": "array([-0.47247706,  0.25229358,  0.59633028])"}︡
︠320eb9bc-faab-4a21-b9ea-ac9a1a736e19︠
dot(a, x) # Verificando a solução (calculando b)
︡8a787213-bb7a-4cd3-baaf-0575abae1b37︡{"stdout": "array([ 2., -4.,  5.])"}︡
︠db6b8ce0-5c21-4412-b64a-16ccacfa0dfa︠
# a*x = b
# inv(a)*a*x = inv(a)*b   # Multiplicando ambos os lados pela inversa de a, para isolar x
# I*x = inv(a)*b          # Como a multiplicação pela matriz identidade não altera o valor, tem-se: x = inv(a)*b
# x = inv(a)*b
x = dot(inv(a), b)
x
︡7e8fdd07-40f2-4a8b-802e-7f157421ecaa︡{"stdout": "array([-0.47247706,  0.25229358,  0.59633028])"}︡
︠f87cfb71-4e43-4387-b3dd-72d859e64fc5︠
dot(inv(a), a)    # Verificando a resposta através do cálculo da matriz identidade
︡7366bae5-929f-4afc-9aff-5dc3ae97d197︡{"stdout": "array([[  1.00000000e+00,   0.00000000e+00,   0.00000000e+00],\n       [  0.00000000e+00,   1.00000000e+00,   0.00000000e+00],\n       [ -5.55111512e-17,  -4.51028104e-17,   1.00000000e+00]])"}︡
︠4b5854e9-cad2-453d-b233-8bfa56061614︠
# Verifica-se que alguns termos não são exatamente zero, mas estão dentro do limite que pode ser considerado.
︡96fcc2d8-c10d-44e6-b809-0e995edc2d43︡︡
